#include "FrustumCullingTraverser.h"
#include "SceneEntity.h"


namespace CHCDemoEngine
{

FrustumCullingTraverser::FrustumCullingTraverser(): RenderTraverser() 
{
}


void FrustumCullingTraverser::Traverse()
{
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		if (mBvh->IsWithinViewFrustum(node))
		{
			TraverseNode(node);
		}
		else
		{
			++ mStats.mNumFrustumCulledNodes;
		}
	}
}


}